<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="600px">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :rules="ruels"
      :model="formData"
      label-width="80px"
    >
      <el-row :gutter="20">
        <el-col :span="12" :offset="0">
          <el-form-item label="状态" prop="state">
            <el-radio-group v-model="formData.state">
              <el-radio :label="3"> 通过 </el-radio>
              <el-radio :label="4"> 驳回 </el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :span="12" :offset="0">
          <el-form-item label="审核日期" prop="checkTime">
            <el-date-picker
              v-model="formData.checkTime"
              type="date"
              format="YYYY-MM-DD"
              value-format="YYYY-MM-DD"
              placeholder="选择日期"
            />
          </el-form-item>
        </el-col>
        <el-col :span="24" :offset="0">
          <el-form-item label="备注" prop="remark">
            <Editor v-model:modelValue="formData.remark" />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script name="DialogAfterSaleAudit" setup>
import { batchAuditAfterSale } from '@/api/clue/afterSale'
import { batchAuditPayment } from '@/api/clue/payment'
import { formatDate } from '@/utils/formatTime'

const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题

const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  state: 3,
  remark: ''
})
const formRef = ref() // 表单 Ref
const ruels = {
  checkTime: { required: true, message: '审核日期不可为空', trigger: 'blur,change' }
}

const formType = ref('aftersale')
const titleMap = {
  aftersale: '批量售后审核',
  feeback: '批量回款审核'
}

/** 打开弹窗 */
const open = (type, ids) => {
  dialogVisible.value = true
  formType.value = type
  dialogTitle.value = titleMap[type] || '批量审核'
  resetForm(ids)
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    if (formType.value == 'aftersale') {
      await batchAuditAfterSale(formData.value)
      message.success('审核完成！')
    } else if (formType.value == 'feeback') {
      await batchAuditPayment(formData.value)
      message.success('审核完成！')
    } else {
      return
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = (ids) => {
  formData.value = {
    payIds: ids,
    saleIds: ids,
    checkTime: formatDate(new Date()),
    state: 3,
    remark: ''
  }
  formRef.value?.resetFields()
}
</script>
